<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
      [solidifyFocusFirstElement]="true"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.submissionPolicies"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             autofocus
             matInput
             tabindex="0"
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.submissionAgreementType) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.submissionAgreementType | translate}}</mat-label>
      <mat-select [formControl]="fd"
      >
        <mat-option *ngFor="let submissionAgreement of submissionAgreementTypes"
                    [value]="submissionAgreement.key"
                    solidifyTooltipOnEllipsis
        >
          {{submissionAgreement.value | translate}}
        </mat-option>
      </mat-select>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.submissionAgreement) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    [matTooltipPosition]="'left'"
                    [matTooltipShowDelay]="TIME_BEFORE_DISPLAY_TOOLTIP"
                    [matTooltip]="'submissionPolicy.tooltips.submissionAgreement' | translate"
                    aria-label="access level"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.submissionAgreements | translate }}</mat-label>
      <mat-select [formControl]="fd"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let accessLevel of listSubmissionAgreements"
                    [value]="accessLevel?.resId"
                    solidifyTooltipOnEllipsis
        >
          {{accessLevel.title}} ({{accessLevel.version}})
        </mat-option>
      </mat-select>
      <button *ngIf="fd.value | isNotNullNorUndefinedNorWhiteString"
              (click)="navigateToAgreementDetail($event, fd.value)"
              [matTooltip]="labelTranslateEnum.seeAgreementDetail | translate"
              aria-label="Navigate to"
              class="navigate-to"
              mat-icon-button
              matSuffix
              solidifyShortCuts
              type="button"
      >
        <solidify-icon [iconName]="iconNameEnum.internalLink"
                       class="size-16"
        ></solidify-icon>
      </button>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.timeToKeep) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.timeToKeep | translate }}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
             type="number"
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

  </ng-template>

  <ng-template #rightTemplate>

    <mat-checkbox [formControlName]="formDefinition.submissionApproval"
                  color="primary"
    >{{labelTranslateEnum.submissionApproval | translate}}</mat-checkbox>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
